#include        "myipc.h"
struct mq_attr attr;

void mqread(mqd_t mqd,char *name)
{
  unsigned prio;
  int n;
  char buffer[100];

  while (1) {
    n = mq_receive(mqd, buffer, 100, &prio);
    if ( n <= 0 )  break;
    buffer[n]=0;
    write(1,"\n",1); write(1,buffer,n);
    write(1,"s> ",3);
  }
  mq_close(mqd);
  mq_unlink(name);
  exit(0);
}

void mqwrite(mqd_t mqd,char *name)
{
  unsigned prio;
  int n;
  char buffer[100];

  while (1) {
    write(1,"S> ",3);
    n=read(0,buffer,100);
    if (n<=0) break;
    prio=1;
    mq_send(mqd, buffer,n, prio);
  }
  mq_close(mqd);
  mq_unlink(name);
  exit(0);
}

int main(int argc, char **argv)
{
  int   c, flags;
  mqd_t mqd;

  flags = O_RDWR | O_CREAT | O_EXCL;
  while ( (c = getopt(argc, argv, "m:z:")) != -1) {
        switch (c) {
        case 'm':
                attr.mq_maxmsg = atol(optarg); break;
       case 'z':
                attr.mq_msgsize = atol(optarg); break;
        }
  }
  if (optind != argc - 1)
        err_quit("usage: msqsv [ -m maxmsg -z msgsize ] <name>");
  if ((attr.mq_maxmsg != 0 && attr.mq_msgsize == 0) ||
        (attr.mq_maxmsg == 0 && attr.mq_msgsize != 0))
        err_quit("must specify both -m maxmsg and -z msgsize");
  if ( attr.mq_msgsize == 0 ) { attr.mq_msgsize=100; attr.mq_maxmsg=10; }
  mqd = mq_open(argv[optind], flags, (S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH),
                          (attr.mq_maxmsg != 0) ? &attr : NULL);
  if ( mqd < 0) err_sys("error mq_open");
  if (fork())  
     mqwrite(mqd,argv[optind]);
  else
     mqread(mqd,argv[optind]);
  exit(0);
}
